/* (c) https://github.com/MontiCore/monticore */
// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: simulationController.proto

package protobuf;

/**
 * Protobuf type {@code SimulationController.SimulationDataFrame}
 */
public  final class SimulationDataFrame extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:SimulationController.SimulationDataFrame)
    SimulationDataFrameOrBuilder {
private static final long serialVersionUID = 0L;
  // Use SimulationDataFrame.newBuilder() to construct.
  private SimulationDataFrame(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private SimulationDataFrame() {
    posX_ = 0D;
    posY_ = 0D;
    posZ_ = 0D;
    steering_ = 0F;
    engine_ = 0F;
    brake_ = 0F;
    rotation_ = java.util.Collections.emptyList();
    deltaTime_ = 0F;
    totalTime_ = 0F;
    battery_ = 0F;
    isCharging_ = false;
  }

  @java.lang.Override
  public final com.google.protobuf.UnknownFieldSet
  getUnknownFields() {
    return this.unknownFields;
  }
  private SimulationDataFrame(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    this();
    if (extensionRegistry == null) {
      throw new java.lang.NullPointerException();
    }
    int mutable_bitField0_ = 0;
    com.google.protobuf.UnknownFieldSet.Builder unknownFields =
        com.google.protobuf.UnknownFieldSet.newBuilder();
    try {
      boolean done = false;
      while (!done) {
        int tag = input.readTag();
        switch (tag) {
          case 0:
            done = true;
            break;
          default: {
            if (!parseUnknownFieldProto3(
                input, unknownFields, extensionRegistry, tag)) {
              done = true;
            }
            break;
          }
          case 9: {

            posX_ = input.readDouble();
            break;
          }
          case 17: {

            posY_ = input.readDouble();
            break;
          }
          case 25: {

            posZ_ = input.readDouble();
            break;
          }
          case 37: {

            steering_ = input.readFloat();
            break;
          }
          case 45: {

            engine_ = input.readFloat();
            break;
          }
          case 53: {

            brake_ = input.readFloat();
            break;
          }
          case 58: {
            if (!((mutable_bitField0_ & 0x00000040) == 0x00000040)) {
              rotation_ = new java.util.ArrayList<protobuf.DoubleArray>();
              mutable_bitField0_ |= 0x00000040;
            }
            rotation_.add(
                input.readMessage(protobuf.DoubleArray.parser(), extensionRegistry));
            break;
          }
          case 66: {
            protobuf.DoubleArray.Builder subBuilder = null;
            if (velocity_ != null) {
              subBuilder = velocity_.toBuilder();
            }
            velocity_ = input.readMessage(protobuf.DoubleArray.parser(), extensionRegistry);
            if (subBuilder != null) {
              subBuilder.mergeFrom(velocity_);
              velocity_ = subBuilder.buildPartial();
            }

            break;
          }
          case 74: {
            protobuf.DoubleArray.Builder subBuilder = null;
            if (acceleration_ != null) {
              subBuilder = acceleration_.toBuilder();
            }
            acceleration_ = input.readMessage(protobuf.DoubleArray.parser(), extensionRegistry);
            if (subBuilder != null) {
              subBuilder.mergeFrom(acceleration_);
              acceleration_ = subBuilder.buildPartial();
            }

            break;
          }
          case 85: {

            deltaTime_ = input.readFloat();
            break;
          }
          case 93: {

            totalTime_ = input.readFloat();
            break;
          }
          case 101: {

            battery_ = input.readFloat();
            break;
          }
          case 104: {

            isCharging_ = input.readBool();
            break;
          }
          case 114: {
            protobuf.BooleanArray.Builder subBuilder = null;
            if (errorFlags_ != null) {
              subBuilder = errorFlags_.toBuilder();
            }
            errorFlags_ = input.readMessage(protobuf.BooleanArray.parser(), extensionRegistry);
            if (subBuilder != null) {
              subBuilder.mergeFrom(errorFlags_);
              errorFlags_ = subBuilder.buildPartial();
            }

            break;
          }
        }
      }
    } catch (com.google.protobuf.InvalidProtocolBufferException e) {
      throw e.setUnfinishedMessage(this);
    } catch (java.io.IOException e) {
      throw new com.google.protobuf.InvalidProtocolBufferException(
          e).setUnfinishedMessage(this);
    } finally {
      if (((mutable_bitField0_ & 0x00000040) == 0x00000040)) {
        rotation_ = java.util.Collections.unmodifiableList(rotation_);
      }
      this.unknownFields = unknownFields.build();
      makeExtensionsImmutable();
    }
  }
  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return protobuf.SimulationControllerProto.internal_static_SimulationController_SimulationDataFrame_descriptor;
  }

  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return protobuf.SimulationControllerProto.internal_static_SimulationController_SimulationDataFrame_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            protobuf.SimulationDataFrame.class, protobuf.SimulationDataFrame.Builder.class);
  }

  private int bitField0_;
  public static final int POSX_FIELD_NUMBER = 1;
  private double posX_;
  /**
   * <code>double posX = 1;</code>
   */
  public double getPosX() {
    return posX_;
  }

  public static final int POSY_FIELD_NUMBER = 2;
  private double posY_;
  /**
   * <code>double posY = 2;</code>
   */
  public double getPosY() {
    return posY_;
  }

  public static final int POSZ_FIELD_NUMBER = 3;
  private double posZ_;
  /**
   * <code>double posZ = 3;</code>
   */
  public double getPosZ() {
    return posZ_;
  }

  public static final int STEERING_FIELD_NUMBER = 4;
  private float steering_;
  /**
   * <code>float steering = 4;</code>
   */
  public float getSteering() {
    return steering_;
  }

  public static final int ENGINE_FIELD_NUMBER = 5;
  private float engine_;
  /**
   * <code>float engine = 5;</code>
   */
  public float getEngine() {
    return engine_;
  }

  public static final int BRAKE_FIELD_NUMBER = 6;
  private float brake_;
  /**
   * <code>float brake = 6;</code>
   */
  public float getBrake() {
    return brake_;
  }

  public static final int ROTATION_FIELD_NUMBER = 7;
  private java.util.List<protobuf.DoubleArray> rotation_;
  /**
   * <code>repeated .SimulationController.DoubleArray rotation = 7;</code>
   */
  public java.util.List<protobuf.DoubleArray> getRotationList() {
    return rotation_;
  }
  /**
   * <code>repeated .SimulationController.DoubleArray rotation = 7;</code>
   */
  public java.util.List<? extends protobuf.DoubleArrayOrBuilder> 
      getRotationOrBuilderList() {
    return rotation_;
  }
  /**
   * <code>repeated .SimulationController.DoubleArray rotation = 7;</code>
   */
  public int getRotationCount() {
    return rotation_.size();
  }
  /**
   * <code>repeated .SimulationController.DoubleArray rotation = 7;</code>
   */
  public protobuf.DoubleArray getRotation(int index) {
    return rotation_.get(index);
  }
  /**
   * <code>repeated .SimulationController.DoubleArray rotation = 7;</code>
   */
  public protobuf.DoubleArrayOrBuilder getRotationOrBuilder(
      int index) {
    return rotation_.get(index);
  }

  public static final int VELOCITY_FIELD_NUMBER = 8;
  private protobuf.DoubleArray velocity_;
  /**
   * <code>.SimulationController.DoubleArray velocity = 8;</code>
   */
  public boolean hasVelocity() {
    return velocity_ != null;
  }
  /**
   * <code>.SimulationController.DoubleArray velocity = 8;</code>
   */
  public protobuf.DoubleArray getVelocity() {
    return velocity_ == null ? protobuf.DoubleArray.getDefaultInstance() : velocity_;
  }
  /**
   * <code>.SimulationController.DoubleArray velocity = 8;</code>
   */
  public protobuf.DoubleArrayOrBuilder getVelocityOrBuilder() {
    return getVelocity();
  }

  public static final int ACCELERATION_FIELD_NUMBER = 9;
  private protobuf.DoubleArray acceleration_;
  /**
   * <code>.SimulationController.DoubleArray acceleration = 9;</code>
   */
  public boolean hasAcceleration() {
    return acceleration_ != null;
  }
  /**
   * <code>.SimulationController.DoubleArray acceleration = 9;</code>
   */
  public protobuf.DoubleArray getAcceleration() {
    return acceleration_ == null ? protobuf.DoubleArray.getDefaultInstance() : acceleration_;
  }
  /**
   * <code>.SimulationController.DoubleArray acceleration = 9;</code>
   */
  public protobuf.DoubleArrayOrBuilder getAccelerationOrBuilder() {
    return getAcceleration();
  }

  public static final int DELTATIME_FIELD_NUMBER = 10;
  private float deltaTime_;
  /**
   * <code>float deltaTime = 10;</code>
   */
  public float getDeltaTime() {
    return deltaTime_;
  }

  public static final int TOTALTIME_FIELD_NUMBER = 11;
  private float totalTime_;
  /**
   * <code>float totalTime = 11;</code>
   */
  public float getTotalTime() {
    return totalTime_;
  }

  public static final int BATTERY_FIELD_NUMBER = 12;
  private float battery_;
  /**
   * <pre>
   * battery percentage
   * </pre>
   *
   * <code>float battery = 12;</code>
   */
  public float getBattery() {
    return battery_;
  }

  public static final int ISCHARGING_FIELD_NUMBER = 13;
  private boolean isCharging_;
  /**
   * <code>bool isCharging = 13;</code>
   */
  public boolean getIsCharging() {
    return isCharging_;
  }

  public static final int ERRORFLAGS_FIELD_NUMBER = 14;
  private protobuf.BooleanArray errorFlags_;
  /**
   * <code>.SimulationController.BooleanArray errorFlags = 14;</code>
   */
  public boolean hasErrorFlags() {
    return errorFlags_ != null;
  }
  /**
   * <code>.SimulationController.BooleanArray errorFlags = 14;</code>
   */
  public protobuf.BooleanArray getErrorFlags() {
    return errorFlags_ == null ? protobuf.BooleanArray.getDefaultInstance() : errorFlags_;
  }
  /**
   * <code>.SimulationController.BooleanArray errorFlags = 14;</code>
   */
  public protobuf.BooleanArrayOrBuilder getErrorFlagsOrBuilder() {
    return getErrorFlags();
  }

  private byte memoizedIsInitialized = -1;
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (posX_ != 0D) {
      output.writeDouble(1, posX_);
    }
    if (posY_ != 0D) {
      output.writeDouble(2, posY_);
    }
    if (posZ_ != 0D) {
      output.writeDouble(3, posZ_);
    }
    if (steering_ != 0F) {
      output.writeFloat(4, steering_);
    }
    if (engine_ != 0F) {
      output.writeFloat(5, engine_);
    }
    if (brake_ != 0F) {
      output.writeFloat(6, brake_);
    }
    for (int i = 0; i < rotation_.size(); i++) {
      output.writeMessage(7, rotation_.get(i));
    }
    if (velocity_ != null) {
      output.writeMessage(8, getVelocity());
    }
    if (acceleration_ != null) {
      output.writeMessage(9, getAcceleration());
    }
    if (deltaTime_ != 0F) {
      output.writeFloat(10, deltaTime_);
    }
    if (totalTime_ != 0F) {
      output.writeFloat(11, totalTime_);
    }
    if (battery_ != 0F) {
      output.writeFloat(12, battery_);
    }
    if (isCharging_ != false) {
      output.writeBool(13, isCharging_);
    }
    if (errorFlags_ != null) {
      output.writeMessage(14, getErrorFlags());
    }
    unknownFields.writeTo(output);
  }

  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (posX_ != 0D) {
      size += com.google.protobuf.CodedOutputStream
        .computeDoubleSize(1, posX_);
    }
    if (posY_ != 0D) {
      size += com.google.protobuf.CodedOutputStream
        .computeDoubleSize(2, posY_);
    }
    if (posZ_ != 0D) {
      size += com.google.protobuf.CodedOutputStream
        .computeDoubleSize(3, posZ_);
    }
    if (steering_ != 0F) {
      size += com.google.protobuf.CodedOutputStream
        .computeFloatSize(4, steering_);
    }
    if (engine_ != 0F) {
      size += com.google.protobuf.CodedOutputStream
        .computeFloatSize(5, engine_);
    }
    if (brake_ != 0F) {
      size += com.google.protobuf.CodedOutputStream
        .computeFloatSize(6, brake_);
    }
    for (int i = 0; i < rotation_.size(); i++) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(7, rotation_.get(i));
    }
    if (velocity_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(8, getVelocity());
    }
    if (acceleration_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(9, getAcceleration());
    }
    if (deltaTime_ != 0F) {
      size += com.google.protobuf.CodedOutputStream
        .computeFloatSize(10, deltaTime_);
    }
    if (totalTime_ != 0F) {
      size += com.google.protobuf.CodedOutputStream
        .computeFloatSize(11, totalTime_);
    }
    if (battery_ != 0F) {
      size += com.google.protobuf.CodedOutputStream
        .computeFloatSize(12, battery_);
    }
    if (isCharging_ != false) {
      size += com.google.protobuf.CodedOutputStream
        .computeBoolSize(13, isCharging_);
    }
    if (errorFlags_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(14, getErrorFlags());
    }
    size += unknownFields.getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof protobuf.SimulationDataFrame)) {
      return super.equals(obj);
    }
    protobuf.SimulationDataFrame other = (protobuf.SimulationDataFrame) obj;

    boolean result = true;
    result = result && (
        java.lang.Double.doubleToLongBits(getPosX())
        == java.lang.Double.doubleToLongBits(
            other.getPosX()));
    result = result && (
        java.lang.Double.doubleToLongBits(getPosY())
        == java.lang.Double.doubleToLongBits(
            other.getPosY()));
    result = result && (
        java.lang.Double.doubleToLongBits(getPosZ())
        == java.lang.Double.doubleToLongBits(
            other.getPosZ()));
    result = result && (
        java.lang.Float.floatToIntBits(getSteering())
        == java.lang.Float.floatToIntBits(
            other.getSteering()));
    result = result && (
        java.lang.Float.floatToIntBits(getEngine())
        == java.lang.Float.floatToIntBits(
            other.getEngine()));
    result = result && (
        java.lang.Float.floatToIntBits(getBrake())
        == java.lang.Float.floatToIntBits(
            other.getBrake()));
    result = result && getRotationList()
        .equals(other.getRotationList());
    result = result && (hasVelocity() == other.hasVelocity());
    if (hasVelocity()) {
      result = result && getVelocity()
          .equals(other.getVelocity());
    }
    result = result && (hasAcceleration() == other.hasAcceleration());
    if (hasAcceleration()) {
      result = result && getAcceleration()
          .equals(other.getAcceleration());
    }
    result = result && (
        java.lang.Float.floatToIntBits(getDeltaTime())
        == java.lang.Float.floatToIntBits(
            other.getDeltaTime()));
    result = result && (
        java.lang.Float.floatToIntBits(getTotalTime())
        == java.lang.Float.floatToIntBits(
            other.getTotalTime()));
    result = result && (
        java.lang.Float.floatToIntBits(getBattery())
        == java.lang.Float.floatToIntBits(
            other.getBattery()));
    result = result && (getIsCharging()
        == other.getIsCharging());
    result = result && (hasErrorFlags() == other.hasErrorFlags());
    if (hasErrorFlags()) {
      result = result && getErrorFlags()
          .equals(other.getErrorFlags());
    }
    result = result && unknownFields.equals(other.unknownFields);
    return result;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    hash = (37 * hash) + POSX_FIELD_NUMBER;
    hash = (53 * hash) + com.google.protobuf.Internal.hashLong(
        java.lang.Double.doubleToLongBits(getPosX()));
    hash = (37 * hash) + POSY_FIELD_NUMBER;
    hash = (53 * hash) + com.google.protobuf.Internal.hashLong(
        java.lang.Double.doubleToLongBits(getPosY()));
    hash = (37 * hash) + POSZ_FIELD_NUMBER;
    hash = (53 * hash) + com.google.protobuf.Internal.hashLong(
        java.lang.Double.doubleToLongBits(getPosZ()));
    hash = (37 * hash) + STEERING_FIELD_NUMBER;
    hash = (53 * hash) + java.lang.Float.floatToIntBits(
        getSteering());
    hash = (37 * hash) + ENGINE_FIELD_NUMBER;
    hash = (53 * hash) + java.lang.Float.floatToIntBits(
        getEngine());
    hash = (37 * hash) + BRAKE_FIELD_NUMBER;
    hash = (53 * hash) + java.lang.Float.floatToIntBits(
        getBrake());
    if (getRotationCount() > 0) {
      hash = (37 * hash) + ROTATION_FIELD_NUMBER;
      hash = (53 * hash) + getRotationList().hashCode();
    }
    if (hasVelocity()) {
      hash = (37 * hash) + VELOCITY_FIELD_NUMBER;
      hash = (53 * hash) + getVelocity().hashCode();
    }
    if (hasAcceleration()) {
      hash = (37 * hash) + ACCELERATION_FIELD_NUMBER;
      hash = (53 * hash) + getAcceleration().hashCode();
    }
    hash = (37 * hash) + DELTATIME_FIELD_NUMBER;
    hash = (53 * hash) + java.lang.Float.floatToIntBits(
        getDeltaTime());
    hash = (37 * hash) + TOTALTIME_FIELD_NUMBER;
    hash = (53 * hash) + java.lang.Float.floatToIntBits(
        getTotalTime());
    hash = (37 * hash) + BATTERY_FIELD_NUMBER;
    hash = (53 * hash) + java.lang.Float.floatToIntBits(
        getBattery());
    hash = (37 * hash) + ISCHARGING_FIELD_NUMBER;
    hash = (53 * hash) + com.google.protobuf.Internal.hashBoolean(
        getIsCharging());
    if (hasErrorFlags()) {
      hash = (37 * hash) + ERRORFLAGS_FIELD_NUMBER;
      hash = (53 * hash) + getErrorFlags().hashCode();
    }
    hash = (29 * hash) + unknownFields.hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static protobuf.SimulationDataFrame parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static protobuf.SimulationDataFrame parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static protobuf.SimulationDataFrame parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static protobuf.SimulationDataFrame parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static protobuf.SimulationDataFrame parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static protobuf.SimulationDataFrame parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static protobuf.SimulationDataFrame parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static protobuf.SimulationDataFrame parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static protobuf.SimulationDataFrame parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static protobuf.SimulationDataFrame parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static protobuf.SimulationDataFrame parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static protobuf.SimulationDataFrame parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(protobuf.SimulationDataFrame prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * Protobuf type {@code SimulationController.SimulationDataFrame}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:SimulationController.SimulationDataFrame)
      protobuf.SimulationDataFrameOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return protobuf.SimulationControllerProto.internal_static_SimulationController_SimulationDataFrame_descriptor;
    }

    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return protobuf.SimulationControllerProto.internal_static_SimulationController_SimulationDataFrame_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              protobuf.SimulationDataFrame.class, protobuf.SimulationDataFrame.Builder.class);
    }

    // Construct using protobuf.SimulationDataFrame.newBuilder()
    private Builder() {
      maybeForceBuilderInitialization();
    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);
      maybeForceBuilderInitialization();
    }
    private void maybeForceBuilderInitialization() {
      if (com.google.protobuf.GeneratedMessageV3
              .alwaysUseFieldBuilders) {
        getRotationFieldBuilder();
      }
    }
    public Builder clear() {
      super.clear();
      posX_ = 0D;

      posY_ = 0D;

      posZ_ = 0D;

      steering_ = 0F;

      engine_ = 0F;

      brake_ = 0F;

      if (rotationBuilder_ == null) {
        rotation_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000040);
      } else {
        rotationBuilder_.clear();
      }
      if (velocityBuilder_ == null) {
        velocity_ = null;
      } else {
        velocity_ = null;
        velocityBuilder_ = null;
      }
      if (accelerationBuilder_ == null) {
        acceleration_ = null;
      } else {
        acceleration_ = null;
        accelerationBuilder_ = null;
      }
      deltaTime_ = 0F;

      totalTime_ = 0F;

      battery_ = 0F;

      isCharging_ = false;

      if (errorFlagsBuilder_ == null) {
        errorFlags_ = null;
      } else {
        errorFlags_ = null;
        errorFlagsBuilder_ = null;
      }
      return this;
    }

    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return protobuf.SimulationControllerProto.internal_static_SimulationController_SimulationDataFrame_descriptor;
    }

    public protobuf.SimulationDataFrame getDefaultInstanceForType() {
      return protobuf.SimulationDataFrame.getDefaultInstance();
    }

    public protobuf.SimulationDataFrame build() {
      protobuf.SimulationDataFrame result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    public protobuf.SimulationDataFrame buildPartial() {
      protobuf.SimulationDataFrame result = new protobuf.SimulationDataFrame(this);
      int from_bitField0_ = bitField0_;
      int to_bitField0_ = 0;
      result.posX_ = posX_;
      result.posY_ = posY_;
      result.posZ_ = posZ_;
      result.steering_ = steering_;
      result.engine_ = engine_;
      result.brake_ = brake_;
      if (rotationBuilder_ == null) {
        if (((bitField0_ & 0x00000040) == 0x00000040)) {
          rotation_ = java.util.Collections.unmodifiableList(rotation_);
          bitField0_ = (bitField0_ & ~0x00000040);
        }
        result.rotation_ = rotation_;
      } else {
        result.rotation_ = rotationBuilder_.build();
      }
      if (velocityBuilder_ == null) {
        result.velocity_ = velocity_;
      } else {
        result.velocity_ = velocityBuilder_.build();
      }
      if (accelerationBuilder_ == null) {
        result.acceleration_ = acceleration_;
      } else {
        result.acceleration_ = accelerationBuilder_.build();
      }
      result.deltaTime_ = deltaTime_;
      result.totalTime_ = totalTime_;
      result.battery_ = battery_;
      result.isCharging_ = isCharging_;
      if (errorFlagsBuilder_ == null) {
        result.errorFlags_ = errorFlags_;
      } else {
        result.errorFlags_ = errorFlagsBuilder_.build();
      }
      result.bitField0_ = to_bitField0_;
      onBuilt();
      return result;
    }

    public Builder clone() {
      return (Builder) super.clone();
    }
    public Builder setField(
        com.google.protobuf.Descriptors.FieldDescriptor field,
        java.lang.Object value) {
      return (Builder) super.setField(field, value);
    }
    public Builder clearField(
        com.google.protobuf.Descriptors.FieldDescriptor field) {
      return (Builder) super.clearField(field);
    }
    public Builder clearOneof(
        com.google.protobuf.Descriptors.OneofDescriptor oneof) {
      return (Builder) super.clearOneof(oneof);
    }
    public Builder setRepeatedField(
        com.google.protobuf.Descriptors.FieldDescriptor field,
        int index, java.lang.Object value) {
      return (Builder) super.setRepeatedField(field, index, value);
    }
    public Builder addRepeatedField(
        com.google.protobuf.Descriptors.FieldDescriptor field,
        java.lang.Object value) {
      return (Builder) super.addRepeatedField(field, value);
    }
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof protobuf.SimulationDataFrame) {
        return mergeFrom((protobuf.SimulationDataFrame)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(protobuf.SimulationDataFrame other) {
      if (other == protobuf.SimulationDataFrame.getDefaultInstance()) return this;
      if (other.getPosX() != 0D) {
        setPosX(other.getPosX());
      }
      if (other.getPosY() != 0D) {
        setPosY(other.getPosY());
      }
      if (other.getPosZ() != 0D) {
        setPosZ(other.getPosZ());
      }
      if (other.getSteering() != 0F) {
        setSteering(other.getSteering());
      }
      if (other.getEngine() != 0F) {
        setEngine(other.getEngine());
      }
      if (other.getBrake() != 0F) {
        setBrake(other.getBrake());
      }
      if (rotationBuilder_ == null) {
        if (!other.rotation_.isEmpty()) {
          if (rotation_.isEmpty()) {
            rotation_ = other.rotation_;
            bitField0_ = (bitField0_ & ~0x00000040);
          } else {
            ensureRotationIsMutable();
            rotation_.addAll(other.rotation_);
          }
          onChanged();
        }
      } else {
        if (!other.rotation_.isEmpty()) {
          if (rotationBuilder_.isEmpty()) {
            rotationBuilder_.dispose();
            rotationBuilder_ = null;
            rotation_ = other.rotation_;
            bitField0_ = (bitField0_ & ~0x00000040);
            rotationBuilder_ = 
              com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders ?
                 getRotationFieldBuilder() : null;
          } else {
            rotationBuilder_.addAllMessages(other.rotation_);
          }
        }
      }
      if (other.hasVelocity()) {
        mergeVelocity(other.getVelocity());
      }
      if (other.hasAcceleration()) {
        mergeAcceleration(other.getAcceleration());
      }
      if (other.getDeltaTime() != 0F) {
        setDeltaTime(other.getDeltaTime());
      }
      if (other.getTotalTime() != 0F) {
        setTotalTime(other.getTotalTime());
      }
      if (other.getBattery() != 0F) {
        setBattery(other.getBattery());
      }
      if (other.getIsCharging() != false) {
        setIsCharging(other.getIsCharging());
      }
      if (other.hasErrorFlags()) {
        mergeErrorFlags(other.getErrorFlags());
      }
      this.mergeUnknownFields(other.unknownFields);
      onChanged();
      return this;
    }

    public final boolean isInitialized() {
      return true;
    }

    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      protobuf.SimulationDataFrame parsedMessage = null;
      try {
        parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        parsedMessage = (protobuf.SimulationDataFrame) e.getUnfinishedMessage();
        throw e.unwrapIOException();
      } finally {
        if (parsedMessage != null) {
          mergeFrom(parsedMessage);
        }
      }
      return this;
    }
    private int bitField0_;

    private double posX_ ;
    /**
     * <code>double posX = 1;</code>
     */
    public double getPosX() {
      return posX_;
    }
    /**
     * <code>double posX = 1;</code>
     */
    public Builder setPosX(double value) {
      
      posX_ = value;
      onChanged();
      return this;
    }
    /**
     * <code>double posX = 1;</code>
     */
    public Builder clearPosX() {
      
      posX_ = 0D;
      onChanged();
      return this;
    }

    private double posY_ ;
    /**
     * <code>double posY = 2;</code>
     */
    public double getPosY() {
      return posY_;
    }
    /**
     * <code>double posY = 2;</code>
     */
    public Builder setPosY(double value) {
      
      posY_ = value;
      onChanged();
      return this;
    }
    /**
     * <code>double posY = 2;</code>
     */
    public Builder clearPosY() {
      
      posY_ = 0D;
      onChanged();
      return this;
    }

    private double posZ_ ;
    /**
     * <code>double posZ = 3;</code>
     */
    public double getPosZ() {
      return posZ_;
    }
    /**
     * <code>double posZ = 3;</code>
     */
    public Builder setPosZ(double value) {
      
      posZ_ = value;
      onChanged();
      return this;
    }
    /**
     * <code>double posZ = 3;</code>
     */
    public Builder clearPosZ() {
      
      posZ_ = 0D;
      onChanged();
      return this;
    }

    private float steering_ ;
    /**
     * <code>float steering = 4;</code>
     */
    public float getSteering() {
      return steering_;
    }
    /**
     * <code>float steering = 4;</code>
     */
    public Builder setSteering(float value) {
      
      steering_ = value;
      onChanged();
      return this;
    }
    /**
     * <code>float steering = 4;</code>
     */
    public Builder clearSteering() {
      
      steering_ = 0F;
      onChanged();
      return this;
    }

    private float engine_ ;
    /**
     * <code>float engine = 5;</code>
     */
    public float getEngine() {
      return engine_;
    }
    /**
     * <code>float engine = 5;</code>
     */
    public Builder setEngine(float value) {
      
      engine_ = value;
      onChanged();
      return this;
    }
    /**
     * <code>float engine = 5;</code>
     */
    public Builder clearEngine() {
      
      engine_ = 0F;
      onChanged();
      return this;
    }

    private float brake_ ;
    /**
     * <code>float brake = 6;</code>
     */
    public float getBrake() {
      return brake_;
    }
    /**
     * <code>float brake = 6;</code>
     */
    public Builder setBrake(float value) {
      
      brake_ = value;
      onChanged();
      return this;
    }
    /**
     * <code>float brake = 6;</code>
     */
    public Builder clearBrake() {
      
      brake_ = 0F;
      onChanged();
      return this;
    }

    private java.util.List<protobuf.DoubleArray> rotation_ =
      java.util.Collections.emptyList();
    private void ensureRotationIsMutable() {
      if (!((bitField0_ & 0x00000040) == 0x00000040)) {
        rotation_ = new java.util.ArrayList<protobuf.DoubleArray>(rotation_);
        bitField0_ |= 0x00000040;
       }
    }

    private com.google.protobuf.RepeatedFieldBuilderV3<
        protobuf.DoubleArray, protobuf.DoubleArray.Builder, protobuf.DoubleArrayOrBuilder> rotationBuilder_;

    /**
     * <code>repeated .SimulationController.DoubleArray rotation = 7;</code>
     */
    public java.util.List<protobuf.DoubleArray> getRotationList() {
      if (rotationBuilder_ == null) {
        return java.util.Collections.unmodifiableList(rotation_);
      } else {
        return rotationBuilder_.getMessageList();
      }
    }
    /**
     * <code>repeated .SimulationController.DoubleArray rotation = 7;</code>
     */
    public int getRotationCount() {
      if (rotationBuilder_ == null) {
        return rotation_.size();
      } else {
        return rotationBuilder_.getCount();
      }
    }
    /**
     * <code>repeated .SimulationController.DoubleArray rotation = 7;</code>
     */
    public protobuf.DoubleArray getRotation(int index) {
      if (rotationBuilder_ == null) {
        return rotation_.get(index);
      } else {
        return rotationBuilder_.getMessage(index);
      }
    }
    /**
     * <code>repeated .SimulationController.DoubleArray rotation = 7;</code>
     */
    public Builder setRotation(
        int index, protobuf.DoubleArray value) {
      if (rotationBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureRotationIsMutable();
        rotation_.set(index, value);
        onChanged();
      } else {
        rotationBuilder_.setMessage(index, value);
      }
      return this;
    }
    /**
     * <code>repeated .SimulationController.DoubleArray rotation = 7;</code>
     */
    public Builder setRotation(
        int index, protobuf.DoubleArray.Builder builderForValue) {
      if (rotationBuilder_ == null) {
        ensureRotationIsMutable();
        rotation_.set(index, builderForValue.build());
        onChanged();
      } else {
        rotationBuilder_.setMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <code>repeated .SimulationController.DoubleArray rotation = 7;</code>
     */
    public Builder addRotation(protobuf.DoubleArray value) {
      if (rotationBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureRotationIsMutable();
        rotation_.add(value);
        onChanged();
      } else {
        rotationBuilder_.addMessage(value);
      }
      return this;
    }
    /**
     * <code>repeated .SimulationController.DoubleArray rotation = 7;</code>
     */
    public Builder addRotation(
        int index, protobuf.DoubleArray value) {
      if (rotationBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureRotationIsMutable();
        rotation_.add(index, value);
        onChanged();
      } else {
        rotationBuilder_.addMessage(index, value);
      }
      return this;
    }
    /**
     * <code>repeated .SimulationController.DoubleArray rotation = 7;</code>
     */
    public Builder addRotation(
        protobuf.DoubleArray.Builder builderForValue) {
      if (rotationBuilder_ == null) {
        ensureRotationIsMutable();
        rotation_.add(builderForValue.build());
        onChanged();
      } else {
        rotationBuilder_.addMessage(builderForValue.build());
      }
      return this;
    }
    /**
     * <code>repeated .SimulationController.DoubleArray rotation = 7;</code>
     */
    public Builder addRotation(
        int index, protobuf.DoubleArray.Builder builderForValue) {
      if (rotationBuilder_ == null) {
        ensureRotationIsMutable();
        rotation_.add(index, builderForValue.build());
        onChanged();
      } else {
        rotationBuilder_.addMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <code>repeated .SimulationController.DoubleArray rotation = 7;</code>
     */
    public Builder addAllRotation(
        java.lang.Iterable<? extends protobuf.DoubleArray> values) {
      if (rotationBuilder_ == null) {
        ensureRotationIsMutable();
        com.google.protobuf.AbstractMessageLite.Builder.addAll(
            values, rotation_);
        onChanged();
      } else {
        rotationBuilder_.addAllMessages(values);
      }
      return this;
    }
    /**
     * <code>repeated .SimulationController.DoubleArray rotation = 7;</code>
     */
    public Builder clearRotation() {
      if (rotationBuilder_ == null) {
        rotation_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000040);
        onChanged();
      } else {
        rotationBuilder_.clear();
      }
      return this;
    }
    /**
     * <code>repeated .SimulationController.DoubleArray rotation = 7;</code>
     */
    public Builder removeRotation(int index) {
      if (rotationBuilder_ == null) {
        ensureRotationIsMutable();
        rotation_.remove(index);
        onChanged();
      } else {
        rotationBuilder_.remove(index);
      }
      return this;
    }
    /**
     * <code>repeated .SimulationController.DoubleArray rotation = 7;</code>
     */
    public protobuf.DoubleArray.Builder getRotationBuilder(
        int index) {
      return getRotationFieldBuilder().getBuilder(index);
    }
    /**
     * <code>repeated .SimulationController.DoubleArray rotation = 7;</code>
     */
    public protobuf.DoubleArrayOrBuilder getRotationOrBuilder(
        int index) {
      if (rotationBuilder_ == null) {
        return rotation_.get(index);  } else {
        return rotationBuilder_.getMessageOrBuilder(index);
      }
    }
    /**
     * <code>repeated .SimulationController.DoubleArray rotation = 7;</code>
     */
    public java.util.List<? extends protobuf.DoubleArrayOrBuilder> 
         getRotationOrBuilderList() {
      if (rotationBuilder_ != null) {
        return rotationBuilder_.getMessageOrBuilderList();
      } else {
        return java.util.Collections.unmodifiableList(rotation_);
      }
    }
    /**
     * <code>repeated .SimulationController.DoubleArray rotation = 7;</code>
     */
    public protobuf.DoubleArray.Builder addRotationBuilder() {
      return getRotationFieldBuilder().addBuilder(
          protobuf.DoubleArray.getDefaultInstance());
    }
    /**
     * <code>repeated .SimulationController.DoubleArray rotation = 7;</code>
     */
    public protobuf.DoubleArray.Builder addRotationBuilder(
        int index) {
      return getRotationFieldBuilder().addBuilder(
          index, protobuf.DoubleArray.getDefaultInstance());
    }
    /**
     * <code>repeated .SimulationController.DoubleArray rotation = 7;</code>
     */
    public java.util.List<protobuf.DoubleArray.Builder> 
         getRotationBuilderList() {
      return getRotationFieldBuilder().getBuilderList();
    }
    private com.google.protobuf.RepeatedFieldBuilderV3<
        protobuf.DoubleArray, protobuf.DoubleArray.Builder, protobuf.DoubleArrayOrBuilder> 
        getRotationFieldBuilder() {
      if (rotationBuilder_ == null) {
        rotationBuilder_ = new com.google.protobuf.RepeatedFieldBuilderV3<
            protobuf.DoubleArray, protobuf.DoubleArray.Builder, protobuf.DoubleArrayOrBuilder>(
                rotation_,
                ((bitField0_ & 0x00000040) == 0x00000040),
                getParentForChildren(),
                isClean());
        rotation_ = null;
      }
      return rotationBuilder_;
    }

    private protobuf.DoubleArray velocity_ = null;
    private com.google.protobuf.SingleFieldBuilderV3<
        protobuf.DoubleArray, protobuf.DoubleArray.Builder, protobuf.DoubleArrayOrBuilder> velocityBuilder_;
    /**
     * <code>.SimulationController.DoubleArray velocity = 8;</code>
     */
    public boolean hasVelocity() {
      return velocityBuilder_ != null || velocity_ != null;
    }
    /**
     * <code>.SimulationController.DoubleArray velocity = 8;</code>
     */
    public protobuf.DoubleArray getVelocity() {
      if (velocityBuilder_ == null) {
        return velocity_ == null ? protobuf.DoubleArray.getDefaultInstance() : velocity_;
      } else {
        return velocityBuilder_.getMessage();
      }
    }
    /**
     * <code>.SimulationController.DoubleArray velocity = 8;</code>
     */
    public Builder setVelocity(protobuf.DoubleArray value) {
      if (velocityBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        velocity_ = value;
        onChanged();
      } else {
        velocityBuilder_.setMessage(value);
      }

      return this;
    }
    /**
     * <code>.SimulationController.DoubleArray velocity = 8;</code>
     */
    public Builder setVelocity(
        protobuf.DoubleArray.Builder builderForValue) {
      if (velocityBuilder_ == null) {
        velocity_ = builderForValue.build();
        onChanged();
      } else {
        velocityBuilder_.setMessage(builderForValue.build());
      }

      return this;
    }
    /**
     * <code>.SimulationController.DoubleArray velocity = 8;</code>
     */
    public Builder mergeVelocity(protobuf.DoubleArray value) {
      if (velocityBuilder_ == null) {
        if (velocity_ != null) {
          velocity_ =
            protobuf.DoubleArray.newBuilder(velocity_).mergeFrom(value).buildPartial();
        } else {
          velocity_ = value;
        }
        onChanged();
      } else {
        velocityBuilder_.mergeFrom(value);
      }

      return this;
    }
    /**
     * <code>.SimulationController.DoubleArray velocity = 8;</code>
     */
    public Builder clearVelocity() {
      if (velocityBuilder_ == null) {
        velocity_ = null;
        onChanged();
      } else {
        velocity_ = null;
        velocityBuilder_ = null;
      }

      return this;
    }
    /**
     * <code>.SimulationController.DoubleArray velocity = 8;</code>
     */
    public protobuf.DoubleArray.Builder getVelocityBuilder() {
      
      onChanged();
      return getVelocityFieldBuilder().getBuilder();
    }
    /**
     * <code>.SimulationController.DoubleArray velocity = 8;</code>
     */
    public protobuf.DoubleArrayOrBuilder getVelocityOrBuilder() {
      if (velocityBuilder_ != null) {
        return velocityBuilder_.getMessageOrBuilder();
      } else {
        return velocity_ == null ?
            protobuf.DoubleArray.getDefaultInstance() : velocity_;
      }
    }
    /**
     * <code>.SimulationController.DoubleArray velocity = 8;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        protobuf.DoubleArray, protobuf.DoubleArray.Builder, protobuf.DoubleArrayOrBuilder> 
        getVelocityFieldBuilder() {
      if (velocityBuilder_ == null) {
        velocityBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            protobuf.DoubleArray, protobuf.DoubleArray.Builder, protobuf.DoubleArrayOrBuilder>(
                getVelocity(),
                getParentForChildren(),
                isClean());
        velocity_ = null;
      }
      return velocityBuilder_;
    }

    private protobuf.DoubleArray acceleration_ = null;
    private com.google.protobuf.SingleFieldBuilderV3<
        protobuf.DoubleArray, protobuf.DoubleArray.Builder, protobuf.DoubleArrayOrBuilder> accelerationBuilder_;
    /**
     * <code>.SimulationController.DoubleArray acceleration = 9;</code>
     */
    public boolean hasAcceleration() {
      return accelerationBuilder_ != null || acceleration_ != null;
    }
    /**
     * <code>.SimulationController.DoubleArray acceleration = 9;</code>
     */
    public protobuf.DoubleArray getAcceleration() {
      if (accelerationBuilder_ == null) {
        return acceleration_ == null ? protobuf.DoubleArray.getDefaultInstance() : acceleration_;
      } else {
        return accelerationBuilder_.getMessage();
      }
    }
    /**
     * <code>.SimulationController.DoubleArray acceleration = 9;</code>
     */
    public Builder setAcceleration(protobuf.DoubleArray value) {
      if (accelerationBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        acceleration_ = value;
        onChanged();
      } else {
        accelerationBuilder_.setMessage(value);
      }

      return this;
    }
    /**
     * <code>.SimulationController.DoubleArray acceleration = 9;</code>
     */
    public Builder setAcceleration(
        protobuf.DoubleArray.Builder builderForValue) {
      if (accelerationBuilder_ == null) {
        acceleration_ = builderForValue.build();
        onChanged();
      } else {
        accelerationBuilder_.setMessage(builderForValue.build());
      }

      return this;
    }
    /**
     * <code>.SimulationController.DoubleArray acceleration = 9;</code>
     */
    public Builder mergeAcceleration(protobuf.DoubleArray value) {
      if (accelerationBuilder_ == null) {
        if (acceleration_ != null) {
          acceleration_ =
            protobuf.DoubleArray.newBuilder(acceleration_).mergeFrom(value).buildPartial();
        } else {
          acceleration_ = value;
        }
        onChanged();
      } else {
        accelerationBuilder_.mergeFrom(value);
      }

      return this;
    }
    /**
     * <code>.SimulationController.DoubleArray acceleration = 9;</code>
     */
    public Builder clearAcceleration() {
      if (accelerationBuilder_ == null) {
        acceleration_ = null;
        onChanged();
      } else {
        acceleration_ = null;
        accelerationBuilder_ = null;
      }

      return this;
    }
    /**
     * <code>.SimulationController.DoubleArray acceleration = 9;</code>
     */
    public protobuf.DoubleArray.Builder getAccelerationBuilder() {
      
      onChanged();
      return getAccelerationFieldBuilder().getBuilder();
    }
    /**
     * <code>.SimulationController.DoubleArray acceleration = 9;</code>
     */
    public protobuf.DoubleArrayOrBuilder getAccelerationOrBuilder() {
      if (accelerationBuilder_ != null) {
        return accelerationBuilder_.getMessageOrBuilder();
      } else {
        return acceleration_ == null ?
            protobuf.DoubleArray.getDefaultInstance() : acceleration_;
      }
    }
    /**
     * <code>.SimulationController.DoubleArray acceleration = 9;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        protobuf.DoubleArray, protobuf.DoubleArray.Builder, protobuf.DoubleArrayOrBuilder> 
        getAccelerationFieldBuilder() {
      if (accelerationBuilder_ == null) {
        accelerationBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            protobuf.DoubleArray, protobuf.DoubleArray.Builder, protobuf.DoubleArrayOrBuilder>(
                getAcceleration(),
                getParentForChildren(),
                isClean());
        acceleration_ = null;
      }
      return accelerationBuilder_;
    }

    private float deltaTime_ ;
    /**
     * <code>float deltaTime = 10;</code>
     */
    public float getDeltaTime() {
      return deltaTime_;
    }
    /**
     * <code>float deltaTime = 10;</code>
     */
    public Builder setDeltaTime(float value) {
      
      deltaTime_ = value;
      onChanged();
      return this;
    }
    /**
     * <code>float deltaTime = 10;</code>
     */
    public Builder clearDeltaTime() {
      
      deltaTime_ = 0F;
      onChanged();
      return this;
    }

    private float totalTime_ ;
    /**
     * <code>float totalTime = 11;</code>
     */
    public float getTotalTime() {
      return totalTime_;
    }
    /**
     * <code>float totalTime = 11;</code>
     */
    public Builder setTotalTime(float value) {
      
      totalTime_ = value;
      onChanged();
      return this;
    }
    /**
     * <code>float totalTime = 11;</code>
     */
    public Builder clearTotalTime() {
      
      totalTime_ = 0F;
      onChanged();
      return this;
    }

    private float battery_ ;
    /**
     * <pre>
     * battery percentage
     * </pre>
     *
     * <code>float battery = 12;</code>
     */
    public float getBattery() {
      return battery_;
    }
    /**
     * <pre>
     * battery percentage
     * </pre>
     *
     * <code>float battery = 12;</code>
     */
    public Builder setBattery(float value) {
      
      battery_ = value;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * battery percentage
     * </pre>
     *
     * <code>float battery = 12;</code>
     */
    public Builder clearBattery() {
      
      battery_ = 0F;
      onChanged();
      return this;
    }

    private boolean isCharging_ ;
    /**
     * <code>bool isCharging = 13;</code>
     */
    public boolean getIsCharging() {
      return isCharging_;
    }
    /**
     * <code>bool isCharging = 13;</code>
     */
    public Builder setIsCharging(boolean value) {
      
      isCharging_ = value;
      onChanged();
      return this;
    }
    /**
     * <code>bool isCharging = 13;</code>
     */
    public Builder clearIsCharging() {
      
      isCharging_ = false;
      onChanged();
      return this;
    }

    private protobuf.BooleanArray errorFlags_ = null;
    private com.google.protobuf.SingleFieldBuilderV3<
        protobuf.BooleanArray, protobuf.BooleanArray.Builder, protobuf.BooleanArrayOrBuilder> errorFlagsBuilder_;
    /**
     * <code>.SimulationController.BooleanArray errorFlags = 14;</code>
     */
    public boolean hasErrorFlags() {
      return errorFlagsBuilder_ != null || errorFlags_ != null;
    }
    /**
     * <code>.SimulationController.BooleanArray errorFlags = 14;</code>
     */
    public protobuf.BooleanArray getErrorFlags() {
      if (errorFlagsBuilder_ == null) {
        return errorFlags_ == null ? protobuf.BooleanArray.getDefaultInstance() : errorFlags_;
      } else {
        return errorFlagsBuilder_.getMessage();
      }
    }
    /**
     * <code>.SimulationController.BooleanArray errorFlags = 14;</code>
     */
    public Builder setErrorFlags(protobuf.BooleanArray value) {
      if (errorFlagsBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        errorFlags_ = value;
        onChanged();
      } else {
        errorFlagsBuilder_.setMessage(value);
      }

      return this;
    }
    /**
     * <code>.SimulationController.BooleanArray errorFlags = 14;</code>
     */
    public Builder setErrorFlags(
        protobuf.BooleanArray.Builder builderForValue) {
      if (errorFlagsBuilder_ == null) {
        errorFlags_ = builderForValue.build();
        onChanged();
      } else {
        errorFlagsBuilder_.setMessage(builderForValue.build());
      }

      return this;
    }
    /**
     * <code>.SimulationController.BooleanArray errorFlags = 14;</code>
     */
    public Builder mergeErrorFlags(protobuf.BooleanArray value) {
      if (errorFlagsBuilder_ == null) {
        if (errorFlags_ != null) {
          errorFlags_ =
            protobuf.BooleanArray.newBuilder(errorFlags_).mergeFrom(value).buildPartial();
        } else {
          errorFlags_ = value;
        }
        onChanged();
      } else {
        errorFlagsBuilder_.mergeFrom(value);
      }

      return this;
    }
    /**
     * <code>.SimulationController.BooleanArray errorFlags = 14;</code>
     */
    public Builder clearErrorFlags() {
      if (errorFlagsBuilder_ == null) {
        errorFlags_ = null;
        onChanged();
      } else {
        errorFlags_ = null;
        errorFlagsBuilder_ = null;
      }

      return this;
    }
    /**
     * <code>.SimulationController.BooleanArray errorFlags = 14;</code>
     */
    public protobuf.BooleanArray.Builder getErrorFlagsBuilder() {
      
      onChanged();
      return getErrorFlagsFieldBuilder().getBuilder();
    }
    /**
     * <code>.SimulationController.BooleanArray errorFlags = 14;</code>
     */
    public protobuf.BooleanArrayOrBuilder getErrorFlagsOrBuilder() {
      if (errorFlagsBuilder_ != null) {
        return errorFlagsBuilder_.getMessageOrBuilder();
      } else {
        return errorFlags_ == null ?
            protobuf.BooleanArray.getDefaultInstance() : errorFlags_;
      }
    }
    /**
     * <code>.SimulationController.BooleanArray errorFlags = 14;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        protobuf.BooleanArray, protobuf.BooleanArray.Builder, protobuf.BooleanArrayOrBuilder> 
        getErrorFlagsFieldBuilder() {
      if (errorFlagsBuilder_ == null) {
        errorFlagsBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            protobuf.BooleanArray, protobuf.BooleanArray.Builder, protobuf.BooleanArrayOrBuilder>(
                getErrorFlags(),
                getParentForChildren(),
                isClean());
        errorFlags_ = null;
      }
      return errorFlagsBuilder_;
    }
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFieldsProto3(unknownFields);
    }

    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:SimulationController.SimulationDataFrame)
  }

  // @@protoc_insertion_point(class_scope:SimulationController.SimulationDataFrame)
  private static final protobuf.SimulationDataFrame DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new protobuf.SimulationDataFrame();
  }

  public static protobuf.SimulationDataFrame getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<SimulationDataFrame>
      PARSER = new com.google.protobuf.AbstractParser<SimulationDataFrame>() {
    public SimulationDataFrame parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return new SimulationDataFrame(input, extensionRegistry);
    }
  };

  public static com.google.protobuf.Parser<SimulationDataFrame> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<SimulationDataFrame> getParserForType() {
    return PARSER;
  }

  public protobuf.SimulationDataFrame getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

